Subject: Re: [PATCH net-next 2/2] ice: add support for Auto FEC with FEC disabled via ETHTOOL_SFECPARAM

From: Jakub Kicinski <[email-masked]>
Date: Tue, 23 Aug 2022 15:17:45 -0700

On Tue, 23 Aug 2022 08:04:38 -0700 Jacob Keller wrote:
> The default Link Establishment State Machine (LESM) behavior does not

LESM is the algo as specified by the IEEE standard? If so could you add
the citation (section of the spec where it's defined)?

Is disabling the only customization we may want?

> allow the use of FEC disabled if the media does not support FEC
> disabled. However users may want to override this behavior.
> 
> To support this, accept the ETHTOOL_FEC_AUTO | ETHTOOL_FEC_OFF as a request
> to automatically select an appropriate FEC mode including potentially
> disabling FEC.
> 
> This is distinct from ETHTOOL_FEC_AUTO because that will not allow the LESM
> to select FEC disabled. It is distinct from ETHTOOL_FEC_OFF because
> FEC_OFF will always disable FEC without any LESM automatic selection.
> 
> This *does* mean that ice is now accepting one "bitwise OR" set for FEC
> configuration, which is somewhat against the recommendations made in
> 6dbf94b264e6 ("ethtool: clarify the ethtool FEC interface"), but I am not
> sure if the addition of an entirely new ETHTOOL_FEC_AUTO_DIS would make any
> sense here.
> 
> With this change, users can opt to allow automatic FEC disable via
> 
>   ethtool --set-fec ethX encoding auto off